力扣: 四数相加II

文章目录

需求

给你四个整数数组 nums1、nums2、nums3 和 nums4 ,数组长度都是 n ,请你计算有多少个元组 (i, j, k, l) 能满足:
0 <= i, j, k, l < n
nums1i + nums2j + nums3k + nums4l == 0

示例 1:

输入:nums1 = 1,2, nums2 = -2,-1, nums3 = -1,2, nums4 = 0,2

输出:2

解释:

两个元组如下:

  1. (0, 0, 0, 1) -> nums10 + nums20 + nums30 + nums41 = 1 + (-2) + (-1) + 2 = 0
  2. (1, 1, 0, 0) -> nums11 + nums21 + nums30 + nums40 = 2 + (-1) + (-1) + 0 = 0

示例 2:

输入:nums1 = 0, nums2 = 0, nums3 = 0, nums4 = 0

输出:1
提示:

n == nums1.length

n == nums2.length

n == nums3.length

n == nums4.length

1 <= n <= 200

-228 <= nums1i, nums2i, nums3i, nums4i <= 228

代码

思路挺简单的, 就是遍历前两个数组, 将其能加起来的和的情况保存在map里, key是和, value是出现的次数, 然后再维护一个count来记录返回值, 再遍历后两个数组, 将其相加的和的负数去map里找, 有的话将 count 加上其value.

代码:

java 复制代码
public int fourSumCount(int[] nums1, int[] nums2, int[] nums3, int[] nums4) {
    int length = nums1.length;
    Map<Integer, Integer> map = new HashMap<>(length * length);
    for (int i = 0; i < length; i++) {
        for (int j = 0; j < length; j++) {
            int n = nums1[i] + nums2[j];
            map.put(n, map.getOrDefault(n, 0) + 1);
        }
    }
    int count = 0;
    for (int i = 0; i < length; i++) {
        for (int j = 0; j < length; j++) {
            int n = nums3[i] + nums4[j];
            if( map.containsKey(-n) ){
                count += map.get(-n);
            }
        }
    }
    return count;
}

代码解释

初始化:

java 复制代码
int length = nums1.length;
Map<Integer, Integer> map = new HashMap<>(length * length);

获取数组的长度(假设所有数组长度相等)。

创建一个 HashMap 用于存储 nums1 和 nums2 元素之和的出现频次。length * length 是一个初始容量估计,理论上足够容纳所有可能的和。

填充 HashMap:

java 复制代码
for (int i = 0; i < length; i++) {
    for (int j = 0; j < length; j++) {
        int n = nums1[i] + nums2[j];
        map.put(n, map.getOrDefault(n, 0) + 1);
    }
}

使用两层嵌套循环遍历 nums1 和 nums2 的所有组合,计算它们的和,并将和及其出现的次数存入 map 中。

计算四元组数量:

java 复制代码
int count = 0;
for (int i = 0; i < length; i++) {
    for (int j = 0; j < length; j++) {
        int n = nums3[i] + nums4[j];
        if (map.containsKey(-n)) {
            count += map.get(-n);
        }
    }
}

通过两层嵌套循环遍历 nums3 和 nums4 的所有组合,计算它们的和。

对于每个和 n,检查 map 是否包含 -n。如果包含,则将 map 中 -n 的计数值加到 count 中。

为什么是 -n?因为我们需要找到 a + b + c + d = 0 的情况,即 a + b = - (c + d)。所以对于 c + d 的和,我们需要在 map 中查找与之相反的值。

返回结果:
return count;

返回符合条件的四元组的数量。

执行结果:

结尾

以上 是我对这道算法的一些遐想和延伸, 可能不是最优解, 但是算法的优化嘛 本身就是一个思索的过程, 能在这个思索和迭代的过程中有所收获和乐趣就是在成长了, 欢迎大家一起来交流更多的解答...

相关推荐
招聘风控观察7 小时前
招聘质量管理是什么?招聘质量的定义与评价口径完整解释
职场和发展
徐小夕8 小时前
花了3个月,我们做了一款 AI 版的“飞书文档”
前端·算法·github
Robert--cao8 小时前
移动底盘与机械臂联合规划:开源算法与工程实现
算法
小豆庄9 小时前
Mac 上给视频人脸打码:本地工具的依赖、追踪与推理管线
算法·视觉检测·视频·敏捷流程·纹理贴图
星夜离尘569 小时前
MATLAB 工程实验:从相邻块均值手写重叠 Allan 偏差,数清有效项
算法·matlab·均值算法
y1su11 小时前
Leetcode 字符串模板
java·数据结构·算法·leetcode·职场和发展·动态规划
residual_fan11 小时前
船用柴油机动态机动工况故障诊断:控制感知仿射网络(CAAN)的技术实现
人工智能·算法·数据挖掘·数据分析
其实防守也摸鱼12 小时前
Cylab在线靶场——CTF中的通用技能
linux·数据库·学习·算法·靶场·ctf·学习网络安全
蓝悦无人机12 小时前
《Planning algorithms》读书笔记——第8章 反馈运动规划
算法·读书笔记·反馈运动规划
RaaS10013 小时前
Agent Skills 进了 Linux Foundation:2.8 亿次安装,但装 skill 还没有安全规范
人工智能·算法·架构